<template>
  <div class="triple-chart-wrapper mt-5">
    <v-row class="align-center justify-space-between" wrap>
      <v-col class="pb-0">
        <h3 v-if="title">{{ title }}</h3>
      </v-col>
      <v-col>
        <v-row class="align-center justify-end mr-1">
          <v-btn
            :class="{ 'v-btn--active': labels }"
            icon
            data-cy="enable-labels"
            @click="labelsMethod()"
          >
            <v-icon>mdi-label</v-icon>
          </v-btn>
          <div class="switch-container">
            <v-label>Total</v-label>
            <v-switch v-model="percentage" label="%"></v-switch>
          </div>
          <v-btn
            v-if="chartsEnabled.columnchart"
            :class="{ 'v-btn--active': chart == 'columnchart' }"
            icon
            @click="chart = 'columnchart'"
          >
            <v-icon>mdi-chart-bar</v-icon>
          </v-btn>
          <v-btn
            v-if="chartsEnabled.barchart"
            :class="{ 'v-btn--active': chart == 'barchart' }"
            icon
            @click="chart = 'barchart'"
          >
            <v-icon>mdi-chart-bar</v-icon>
          </v-btn>
          <v-btn
            v-if="chartsEnabled.treemap"
            :class="{ 'v-btn--active': chart == 'treemap' }"
            icon
            @click="chart = 'treemap'"
          >
            <v-icon>mdi-dashboard</v-icon>
          </v-btn>
          <v-btn
            v-if="chartsEnabled.timeline"
            :class="{ 'v-btn--active': chart == 'timeline' }"
            icon
            @click="chart = 'timeline'"
          >
            <v-icon>mdi-chart-timeline-variant</v-icon>
          </v-btn>
          <v-btn
            v-if="chartsEnabled.sankey"
            :class="{ 'v-btn--active': chart == 'sankey' }"
            icon
            @click="chart = 'sankey'"
          >
            <v-icon>mdi-shuffle</v-icon>
          </v-btn>
          <v-btn
            v-if="chartsEnabled.area"
            :class="{ 'v-btn--active': chart == 'area' }"
            icon
            @click="chart = 'area'"
          >
            <v-icon>mdi-show-chart</v-icon>
          </v-btn>
          <v-btn
            v-if="chartsEnabled.donut"
            :class="{ 'v-btn--active': chart == 'donut' }"
            icon
            @click="chart = 'donut'"
          >
            <v-icon>mdi-chart-donut</v-icon>
          </v-btn>
        </v-row>
      </v-col>
    </v-row>
    <v-row wrap>
      <v-col xs="12">
        <Barchart
          v-if="chartsEnabled.columnchart"
          v-show="chart === 'columnchart'"
          :series="dataBarchart"
          :suffix="percentage ? '%' : ''"
          :plot-mode="barMode"
          :categories="categories"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
        />
        <Barchart
          v-if="chartsEnabled.barchart"
          v-show="chart === 'barchart'"
          :series="dataBarchart"
          :suffix="percentage ? '%' : ''"
          :plot-mode="barMode"
          :categories="categories"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
          type="bar"
        />
        <Treemap
          v-if="chartsEnabled.treemap"
          v-show="chart == 'treemap'"
          :series="dataTreemap"
          :suffix="percentage ? '%' : ''"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
        />
        <Timeline
          v-if="chartsEnabled.timeline"
          v-show="chart == 'timeline'"
          :series="dataTimeline"
          :suffix="percentage ? '%' : ''"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
        />
        <Sankey
          v-if="chartsEnabled.sankey"
          v-show="chart == 'sankey'"
          :series="dataBarchart"
          :suffix="percentage ? '%' : ''"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
        />
        <Area
          v-if="chartsEnabled.area"
          v-show="chart == 'area'"
          :series="dataBarchart"
          :suffix="percentage ? '%' : ''"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
        />
        <Donut
          v-if="chartsEnabled.donut"
          v-show="chart == 'donut'"
          :series="donutSeries"
          :suffix="percentage ? '%' : ''"
          :colors="colors"
          :labels="labels"
          :height="height"
          :width="width"
        />
        <v-alert
          v-if="series.length === 0 && updated"
          border="left"
          color="red"
          text
          type="info"
          class="mt-1"
          >{{ $t('no-data') }}</v-alert
        >
      </v-col>
    </v-row>
  </div>
</template>
<script>
import * as d3 from 'd3'
import * as _ from 'lodash'
import Barchart from '@/components/charts/Barchart.vue'
import Timeline from '@/components/charts/Timeline.vue'
import Treemap from '@/components/charts/Treemap.vue'
import Sankey from '@/components/charts/Sankey.vue'
import Area from '@/components/charts/Area.vue'
import Donut from '@/components/charts/Donut.vue'
export default {
  components: {
    Barchart,
    Timeline,
    Treemap,
    Sankey,
    Area,
    Donut,
  },
  props: {
    series: {
      type: Array,
      required: true,
    },
    title: {
      type: String,
      default: '',
    },
    chartsEnabled: {
      type: Object,
      default: () => ({
        columnchart: true,
        barchart: false,
        treemap: false,
        timeline: false,
        sankey: false,
      }),
      required: true,
    },
    plotMode: {
      type: String,
      default: 'normal',
    },
    colors: {
      type: Array,
      default: undefined,
    },
    height: {
      type: String,
      default: undefined,
    },
    width: {
      type: String,
      default: undefined,
    },
    labels: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      updated: false,
      percentage: false,
      chart: Object.keys(this.chartsEnabled)[0],
    }
  },
  computed: {
    categories() {
      return _.uniq(this.series.map((o) => o.name))
    },
    barMode() {
      if (this.plotMode === 'drilldown') {
        return 'drilldown'
      } else if (
        (this.series[0] &&
          // eslint-disable-next-line no-prototype-builtins
          this.series[0].hasOwnProperty('sub') &&
          this.series[0].sub !== undefined) ||
        this.plotMode === 'stacked'
      ) {
        return 'stacked'
      } else {
        return 'normal'
      }
    },
    dataBarchart() {
      const data = d3
        .nest()
        .key((d) => `${d.name}-${d.sub}`)
        .entries(this.series)
        .map((d) => {
          const filter = d.values.filter((o) => d.key === `${o.name}-${o.sub}`)
          return {
            name: d.values[0].name,
            sub: d.values[0].sub,
            y: d3.sum(filter, (i) => i.y),
          }
        })
      if (this.percentage) {
        if (data[0]?.sub !== undefined) {
          const tmp = d3
            .nest()
            .key((d) => d.name)
            .entries(data)
            .map((d) => {
              return {
                name: d.values[0].name,
                sub: d.values[0].sub,
                y: d3.sum(d.values, (i) => i.y),
                values: d.values,
              }
            })
          const total = d3.sum(data, (o) => o.y)
          return data.map((o) => {
            const byGroup = tmp.find((d) => d.name === o.name).y
            o.y = (o.y / byGroup) * 100
            o.total = (byGroup / total) * 100
            return o
          })
        } else {
          // Calculate percentage with data
          const total = d3.sum(data, (o) => o.y)
          return data.map((o) => {
            o.y = (o.y / total) * 100
            return o
          })
        }
      } else {
        return data
      }
    },
    dataTreemap() {
      const data = d3
        .nest()
        .key((d) => `${d.name}-${d.sub}`)
        .entries(this.series)
        .map((d) => {
          const filter = d.values.filter((o) => d.key === `${o.name}-${o.sub}`)
          return {
            name: d.values[0].name,
            sub: d.values[0].sub,
            value: d3.sum(filter, (i) => i.y),
          }
        })
      if (this.percentage) {
        // Calculate percentage with data
        const total = d3.sum(data, (o) => o.value)
        return data.map((o) => {
          o.value = (o.value / total) * 100
          return o
        })
      } else {
        return data
      }
    },
    dataTimeline() {
      const self = this
      let data = _.cloneDeep(self.series) // Default series
      if (self.percentage) {
        // Calculate percentage by date
        data = data.map((obj) => {
          const filter = self.series.filter((j) => j.concat === obj.concat) // Same year and month
          const tot = d3.sum(filter, (i) => i.y)
          obj.y = (obj.y / tot) * 100
          return obj
        })
      }
      return d3
        .nest()
        .key((d) => d.name)
        .entries(data)
        .map((d) => {
          return {
            name: d.key,
            data: d.values.map((o) => {
              return [o.date.toDate().getTime(), o.y]
            }),
          }
        })
    },
    donutSeries() {
      if (this.percentage) {
        const total = d3.sum(this.series, (d) => d.y)
        return JSON.parse(JSON.stringify(this.series)).map((o) => {
          o.y = (o.y / total) * 100
          return o
        })
      } else {
        return this.series
      }
    },
  },
  watch: {},
  updated() {
    this.updated = true
  },
  methods: {
    labelsMethod() {
      // eslint-disable-next-line vue/no-mutating-props
      return (this.labels = !this.labels)
    },
  },
  render(createElement) {
    return createElement('div')
  },
}
</script>
<style>
.switch-container .v-label {
  font-size: 0.8em;
  display: inline-block;
  margin-right: 0.5em;
}
.switch-container {
  align-items: center;
  display: flex;
}
.switch-container .v-input--switch {
  display: inline-block;
  margin: 0;
  height: 30px;
}
</style>
